//  The elimination matrix of size size x size
//  with entry entry in row row and column col.

#include <math.h>
#include "vecdefs.h"
#include MATRIX_H 
  
MATRIX_double elim(int size,int row,int col,double entry)
{
MATRIX_double A(size,size);  
  int i;
  int j;
  {
    
    for(i = 1;i <= size;i++)
      for(j = 1;j <= size;j++)
        if( i == j )
          A(i-1,j-1) = 0.1E1;
        else 
          A(i-1,j-1) = 0.0;
    A(row-1,col-1) = entry;
    return(A);
  }
}

