 
#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<iostream.h>
#include "vecdefs.h"
#include "mvm.h"

//ostream&   operator<<(ostream& s, const MV_ColMat_float& V)
void prntmat(const MV_ColMat_double&  V)
{
    int M = V.dim(0);
    int N = V.dim(1);

    for (int i=0; i<M; i++)
    {
        for (int j=0; j<N; j++)
            printf(" %12g", V(i,j)) ;
        cout << endl;
    }
    
     
}


 
double main(void)
{
  double c;
  double d;
  int m;
  double l;
  double g(double);
 
  double trap(double(double),double,double,int);
MV_ColMat_double romberg(double(double),double,double,int);
void prntmat(MV_ColMat_double&);

  c = 0.1E1;
  d = 0.2E1;
  m = 2;
  l = trap(g,c,d,m);
 MV_ColMat_double A(m,m);
  A = romberg(g,c,d,2);
  prntmat(&A);
}

MV_ColMat_double romberg(double f(double),double a,double b,int n)
{
   
 int i;
  int j;
 
  double trap(double (double),double,double,int);

  MATRIX_double rom(n,n,0) ;
  for(i = 1;(i <= n);i++)
    rom(i-1,0) = trap(f,a,b,i);
  for(j = 2;(j <= n);j++)
    for(i = j;(i <= n);i++)
      rom(i-1,j-1) = (pow(4,j-1)*rom(i-1,j-2)-rom(i-2,j-2))/(pow(4,j-1)-1);
  return(rom);
}

/* The options were    : remember */
double trap(double f(double),double a,double b,int n)
{
  int i;
  double h;
  double s;

  h = b-a;
  if (n == 1)
    return(h*(f(a)+f(b))/2);
  else 
    {
      s = 0;
      for(i = 1;(i <= pow(2,n-2));i++)
        s += f(a+(2*i-1)*h/pow(2,n-1));
      s = h/pow(2,n-1)*(s+0.5*trap(f,a,b,n-1));
    }
}

/* The options were    : operatorarrow */
double g(double x)
{
  return((sin(x)+x*x)*exp(x));
}
