 
#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<iostream.h>
#include "vecdefs.h"
#include MATRIX_H
double c;
  double d;
  int m;
  double l;

   double trap(double(double),double,double,int); 
   double romberg(double(double),double,double,int); 
   double g(double);
double main(void)
{
  
  c = 0.1E1;
  d = 0.2E1;
  m = 2;
  l = trap(g,c,d,m);
  printf( "%e\n" ,l);
  romberg(g,.3,5.5,3);
}

double romberg(double f(double),double a,double b,int n)
{
   
  int i;
  int j;

   MATRIX_double rom(n,n); 
  // trap(double(double),double,double,int); 
  for(i = 1;(i <= n);i++)
    rom(i-1,0) = trap(f,a,b,i);
  for(j = 2;(j <= n);j++)
    for(i = j;(i <= n);i++)
      rom(i-1,j-1) = (pow(4,j-1)*rom(i-1,j-2)-rom(i-2,j-2))/(pow(4,j-1)-1);
  cout << rom;
}

/* The options were    : remember */
double trap(double f(double),double a,double b,int n)
{
  int i;
  double h;
  double s;

 //  double trap(double(double),double,double,int); 
  h = b-a;
  if (n == 1)
    return(h*(f(a)+f(b))/2);
  else 
    {
      s = 0;
      for(i = 1;(i <= pow(2,n-2));i++)
        s += f(a+(2*i-1)*h/pow(2,n-1));
      s = h/pow(2,n-1)*(s+0.5*trap(f,a,b,n-1));
    }
}

/* The options were    : operatorarrow */
double g(double x)
{
  return((sin(x)+x*x)*exp(x));
}
